import numpy as np

print('---------------------------------')
v1 = np.zeros(3, dtype=np.float32)
print(v1)
print(type(v1))
print(v1.dtype)
print('---------------------------------')
v2 = np.zeros(3, dtype=np.uint8)
print(v2)
print(type(v2))
print(v2.dtype)
print('---------------------------------')
v3 = np.zeros_like(v1)
print(v3)
print(type(v3))
print(v3.dtype)
print('---------------------------------')
v4 = np.ones(6, dtype=np.float32)
print(v4)
print(v4.dtype)
print('---------------------------------')
m1 = np.zeros((3,6), dtype=np.float16)
print(m1)
print(m1.dtype)
print('---------------------------------')
m2 = np.ones((3,6), dtype=np.float16)
print(m2)
print(m2.dtype)
print('---------------------------------')
m3 = np.eye(3, dtype=np.float16)
print(m3)
print(m3.dtype)
print('---------------------------------')
v5 = np.array([0.1, 1.2, 2.3])
print(v5)
print(v5.dtype)
print('---------------------------------')
v6 = np.array([0, 1, 2])
print(v6)
print(v6.dtype)

print('---------------------------------')
print('Anlegen von 2 Vektoren')
v1 = np.array([1,2,3], dtype=np.float32)
print('v1= ', v1)
v2 = np.array([4,5,6], dtype=np.float32)
print('v2= ', v2)
print('---------------------------------')
print('Anlegen einer Matrix')
m1 = np.array([[1, 2, 3],
               [4, 5, 6],
               [7, 8, 9]], dtype=np.float32)
print('m1= ', m1)
print('---------------------------------')
print('Matrixmultiplikation')
v3a = np.matmul(v1, m1)
print('v1*m1= ', v3a)
print('---------------------------------')
print('Elementweise Multiplikation')
v3b = np.multiply(v1, m1)
print('v1.*m1= ', v3b)
print('---------------------------------')
print('Matrix transponieren')
m2 = m1.transpose()
print('m1: ', m1)
print('m2: ', m2)
print('---------------------------------')
print('Matrixmultiplikation mit der Transponierten')
v4 = np.matmul(v1, m1.transpose())
print('v1*m1\'= ', v4)
print('---------------------------------')
print('Vektor-/Matrix-Addition')
v5 = v1 + v2
print('v5= ', v5)
print('---------------------------------')
print('Vektor-/Matrix-Addition verschachtelt mit Matrixmultiplikation')
v6 = np.matmul((v1+v2), m2)
print('v6= ', v6)
print('---------------------------------')
print('Multiplikation von 2 Matrizen')
m3 = np.matmul(m1, m2)
print('m1*m2= ', m3)
print('---------------------------------')